#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <math.h>

#define EPS 0.00001

typedef struct {
	double x;
	double y;
} p;

typedef struct {
	p pt[4];
} c;

int n;
p s;
p e;
p train;
double l;

c a[256];

double mi;
double mx;
double be[256];
double en[256];

void ins(double p) {
  if (p<mi)
    mi = p;
  if (p>mx)
    mx = p;
}

double len(p a) {
	return sqrt (a.x*a.x + a.y*a.y);
}

double dist(p a, p b) {
	a.x -= b.x;
	a.y -= b.y;
	return len(a);
}

p sub(p a, p b) {
	p r = a;
	r.x -= b.x;
	r.y -= b.y;
	return r;
}

p add(p a, p b) {
	p r = a;
	r.x += b.x;
	r.y += b.y;
	return r;
}

p mul(p a, double l) {
	a.x *= l;
	a.y *= l;
	return a;
}
void norm(p *a) {
	double l = len(*a);
	a->x /= l;
	a->y /= l;
}

p proj(p a, p b) {
	double l = a.x*b.x + a.y*b.y;
	b = mul(b, l);
	return b;
}

double projd(p a, p b) {
	double l = a.x*b.x + a.y*b.y;
	return l;
}

int cmp(double*a, double*b) {
  if ((*a-*b) < 0)
    return -1;
  if ((*a-*b) > 0)
    return 1;
  return 0;
}

int main() {
	while (true) {
		scanf("%i", &n);
		if (!n)
			break;

		scanf("%lf %lf %lf %lf", &s.x, &s.y, &e.x, &e.y);
		int i,j,k;
		for (i=0; i<n;i++) {
			for (j=0; j<4; j++) {
				scanf("%lf %lf", &a[i].pt[j].x, &a[i].pt[j].y);
			}
		}

		l=dist(s,e);
		train = sub(e,s);
		norm(&train);
		for (i=1; i<n;i++) {
			mi = l;
			mx = 0;
			for (j=0; j<4; j++) {
				for (k=0; k<4; k++) {
					p M = a[0].pt[j];
					p A = a[i].pt[k];

					M = sub(M, s);
					A = sub(A, s);
					p mproj = proj(M, train);
					//printf("DEBUG:%lf\n", len(sub(proj(mproj,train),mproj)));
					//printf("DEBUG:%lf\n", len(sub( proj(proj(mproj,train), train), proj(mproj,train))));
					p aproj = proj(A, train);
					p mdist = sub(M, mproj);
					p adist = sub(A, aproj);
					double mdistl = len(mdist);
					double adistl = len(adist);
					if (mdistl - adistl > EPS) {
						p tx= sub (aproj, mproj);
						p ty=sub (adist, mdist);

						double scale = len(mdist) / len(ty);
						tx= mul(tx, scale);
						tx = add(tx,mproj);

						ins(projd(tx, train));
					}
				}
			}
			be[i-1] = mi;
			en[i-1] = mx;
		}
		qsort(be, n-1,sizeof(double),cmp);
		qsort(en, n-1,sizeof(double),cmp);
		i = 0;
		j =0;
		double sum =0;
		double end = 0;
		while (i<n-1) {
		  if (be[i] > end) {
		    sum += be[i]-end;
		  }
		  if (end < en[i])
		    end = en[i];
		  i++;
		}
		printf("%lf\n", l - sum);
	}
	return 0;
}
